/*
    WebBrowser wlx plugin for Total Commander
    Copyright (C) 2005 Shynkarenka Ivan

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
/*//////////////////////////////////////////////////////////////////////////////
//                      WEB BROWSER WLX PLUGIN                                //
//                                                                            //
// AUTHOR:  Mausau (www.codeguru.com)                                         //
// GROUP:   NULL workgroup                                                    //
// PROJECT: The project                                                       //
// PART:    WLX plugin                                                        //
// CREATED: 22.03.2005                                                        //
//////////////////////////////////////////////////////////////////////////////*/
#include <WebBrowser.h>
/*============================================================================*/
LRESULT CALLBACK WebBrowserProc(HWND hwnd,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
 CWebBrowser *pthis=(CWebBrowser*)GetProp(hwnd,"this");

 if (!pthis)
 {
  if (uMsg!=WM_CREATE)
   return DefWindowProc(hwnd,uMsg,wParam,lParam);
  pthis=new CWebBrowser(hwnd);
  SetProp(hwnd,"this",(HANDLE)pthis);
 }
 LRESULT lResult=pthis->WebBrowserProc(uMsg,wParam,lParam);
 if (uMsg==WM_DESTROY)
 {
  RemoveProp(hwnd,"this");
  delete pthis;
 }
 return lResult;
}
/*============================================================================*/
CWebBrowser::CWebBrowser(HWND hwnd)
{
 this->m_hwnd=hwnd;
 this->m_cxScroll=GetSystemMetrics(SM_CXHSCROLL)+2;
 this->m_cyScroll=GetSystemMetrics(SM_CYVSCROLL)+2;
 lstrcpyn(this->path,"",256);
}
/*----------------------------------------------------------------------------*/
bool CWebBrowser::InstallWebBrowser(HINSTANCE hinst)
{
 CoInitialize(NULL);
 WNDCLASS wc;

 if (!GetClassInfo(hinst,WC_WEBCTRL,&wc))
 {
  memset(&wc,0,sizeof(wc));

  wc.style         = CS_DBLCLKS|CS_GLOBALCLASS|CS_NOCLOSE;
  wc.lpfnWndProc   = ::WebBrowserProc;
  wc.hInstance     = hinst;
  wc.hCursor       = LoadCursor(NULL,IDC_ARROW);
  wc.lpszClassName = WC_WEBCTRL;
  return RegisterClass(&wc)?true:false;
 }
 return true;
}
/*----------------------------------------------------------------------------*/
bool CWebBrowser::UninstallWebBrowser(HINSTANCE hinst)
{
 WNDCLASS wc;
 bool bResult=false;
 if (GetClassInfo(hinst,WC_WEBCTRL,&wc))
  bResult=UnregisterClass(WC_WEBCTRL,wc.hInstance)?true:false;
 CoUninitialize();
 return bResult;
}
/*----------------------------------------------------------------------------*/
LRESULT CWebBrowser::WebBrowserProc(UINT uMsg,WPARAM wParam,LPARAM lParam)
{
 LRESULT lResult=0;
 switch (uMsg)
 {
  case WM_CREATE:
  {
   CREATESTRUCT *pcs;
   pcs=(CREATESTRUCT*)lParam;
   this->m_pContainer=new CWebContainer(this->m_hwnd);
   this->m_pContainer->AddRef();
   this->m_pContainer->add();
   this->m_pContainer->navigate((LPTSTR)pcs->lpszName);
   break;
  }
  case WM_SETTEXT:
  {
   lstrcpyn(this->path,(LPTSTR)lParam,256);
   this->m_pContainer->navigate((LPTSTR)lParam);
   break;
  }
  case WM_GETTEXT:
  {
   lResult=(LRESULT)((wParam<256)?wParam:256);
   lstrcpyn((char*)(lParam),this->path,(int)lResult);
   break;
  }
  case WM_SIZE:
  {
   RECT rect1,rect2;
   int w,h;
   GetClientRect(this->m_hwnd,&rect1);
   GetClientRect((HWND)GetProp(this->m_hwnd,PROP_STATUS),&rect2);
   w=rect1.right-rect1.left;
   h=rect1.bottom-rect1.top-rect2.bottom+rect2.top;
   MoveWindow((HWND)GetProp(this->m_hwnd,PROP_STATUS),0,h,rect1.right-rect1.left,rect2.bottom-rect2.top,TRUE);
   this->m_pContainer->setLocation(0,0,w/*+m_cxScroll*/,h/*+m_cyScroll*/);
   break;
  }
  case WM_SETFOCUS:
  {
   this->m_pContainer->setFocus(true);
   break;
  }
  case WM_KILLFOCUS:
  {
   this->m_pContainer->setFocus(false);
   break;
  }
  case WM_DESTROY:
  {
   this->m_pContainer->remove();
   this->m_pContainer->Release();
   break;
  }
  default:
  {
   lResult=DefWindowProc(this->m_hwnd,uMsg,wParam,lParam);
   break;
  }
 }
 return lResult;
}
/*============================================================================*/
