/*
    WebBrowser wlx plugin for Total Commander
    Copyright (C) 2005 Shynkarenka Ivan

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
/*//////////////////////////////////////////////////////////////////////////////
//                      WEB BROWSER WLX PLUGIN                                //
//                                                                            //
// AUTHOR:  Mausau (www.codeguru.com)                                         //
// GROUP:   NULL workgroup                                                    //
// PROJECT: The project                                                       //
// PART:    WLX plugin                                                        //
// CREATED: 22.03.2005                                                        //
//////////////////////////////////////////////////////////////////////////////*/
#include <WebContainer.h>
/*============================================================================*/
CWebContainer::CWebContainer(HWND hwnd)
{
 m_cRef=0;
 m_hwnd=hwnd;
 m_punk=NULL;
 SetRectEmpty(&m_rect);
 m_pEvent=new CWebEventSink(this);
 m_pEvent->AddRef();
}
/*----------------------------------------------------------------------------*/
CWebContainer::~CWebContainer(void)
{
 m_pEvent->Release();
 m_punk->Release();
}
/*----------------------------------------------------------------------------*/
void CWebContainer::add(void)
{
 CLSID clsid;
 CLSIDFromString(L"Shell.Explorer",&clsid);
 CoCreateInstance(clsid,NULL,CLSCTX_INPROC,IID_IUnknown,(PVOID*)&m_punk);

 IOleObject *pioo;
 m_punk->QueryInterface(IID_IOleObject,(PVOID*)&pioo);
 pioo->SetClientSite(this);
 pioo->Release();

 IPersistStreamInit *ppsi;
 m_punk->QueryInterface(IID_IPersistStreamInit,(PVOID*)&ppsi);
 ppsi->InitNew();
 ppsi->Release();

 ConnectEvents();
 setVisible(true);
 setFocus(true);
}
/*----------------------------------------------------------------------------*/
void CWebContainer::remove(void)
{
 IOleObject *pioo;
 m_punk->QueryInterface(IID_IOleObject,(PVOID*)&pioo);
 pioo->Close(OLECLOSE_NOSAVE);
 pioo->SetClientSite(NULL);
 pioo->Release();

 IOleInPlaceObject *pipo;
 m_punk->QueryInterface(IID_IOleInPlaceObject,(PVOID*)&pipo);
 pipo->UIDeactivate();
 pipo->InPlaceDeactivate();
 pipo->Release();
 DisconnectEvents();
}
/*----------------------------------------------------------------------------*/
void CWebContainer::navigate(LPTSTR psz)
{
 if (!psz)
  return;
 if (!*psz)
  return;
 int len=lstrlen(psz)+1;
 WCHAR *pszW;
#ifndef UNICODE
 pszW=new WCHAR[len];
 MultiByteToWideChar(CP_ACP,0,psz,-1,pszW,len);
#else
 pszW=psz;
#endif
 VARIANT v;
 VariantInit(&v);
 v.vt=VT_BSTR;
 v.bstrVal=SysAllocString(pszW);
#ifndef UNICODE
 delete [] pszW;
#endif
 IWebBrowser2* ppweb;
 m_punk->QueryInterface(IID_IWebBrowser2,(PVOID*)&ppweb);
 ppweb->Navigate2(&v,NULL,NULL,NULL,NULL);
 ppweb->Release();
 VariantClear(&v);
}
/*----------------------------------------------------------------------------*/
void CWebContainer::status(LPTSTR psz)
{
 ::SetWindowText((HWND)GetProp(this->m_hwnd,PROP_STATUS),psz);
}
/*----------------------------------------------------------------------------*/
void CWebContainer::setLocation(int x,int y,int cx,int cy)
{
 m_rect.left   = x;
 m_rect.top    = y;
 m_rect.right  = cx;
 m_rect.bottom = cy;

 IOleInPlaceObject *pipo;
 m_punk->QueryInterface(IID_IOleInPlaceObject,(PVOID*)&pipo);
 pipo->SetObjectRects(&m_rect,&m_rect);
 pipo->Release();
}
/*----------------------------------------------------------------------------*/
void CWebContainer::setVisible(bool bVisible)
{
 IOleObject *pioo;
 m_punk->QueryInterface(IID_IOleObject,(PVOID*)&pioo);

 if (bVisible)
 {
  pioo->DoVerb(OLEIVERB_INPLACEACTIVATE,NULL,this,0,m_hwnd,&m_rect);
  pioo->DoVerb(OLEIVERB_SHOW,NULL,this,0,m_hwnd,&m_rect);
 }
 else
  pioo->DoVerb(OLEIVERB_HIDE,NULL,this,0,m_hwnd,NULL);
 pioo->Release();
}
/*----------------------------------------------------------------------------*/
void CWebContainer::setFocus(bool bFocus)
{
 IOleObject *pioo;
 if (bFocus)
 {
  m_punk->QueryInterface(IID_IOleObject,(PVOID*)&pioo);
  pioo->DoVerb(OLEIVERB_UIACTIVATE,NULL,this,0,m_hwnd,&m_rect);
  pioo->Release();
 }
}
/*----------------------------------------------------------------------------*/
void CWebContainer::ConnectEvents(void)
{
 IConnectionPoint *pcp=GetConnectionPoint(DIID_DWebBrowserEvents2);
 pcp->Advise(m_pEvent,&m_eventCookie);
 pcp->Release();
}
/*----------------------------------------------------------------------------*/
void CWebContainer::DisconnectEvents(void)
{
 IConnectionPoint *pcp;
 pcp=GetConnectionPoint(DIID_DWebBrowserEvents2);
 pcp->Unadvise(m_eventCookie);
 pcp->Release();
}
/*----------------------------------------------------------------------------*/
IConnectionPoint* CWebContainer::GetConnectionPoint(REFIID riid)
{
 IConnectionPointContainer *pcpc;
 m_punk->QueryInterface(IID_IConnectionPointContainer,(PVOID*)&pcpc);

 IConnectionPoint *pcp;
 pcpc->FindConnectionPoint(riid,&pcp);
 pcpc->Release();
 return pcp;
}
/*============================================================================*/
